clear
close all
clc

% Test all conditions
sampling_all = {'normal'; 'hourly'; '5'};
dist_type_all = {'beta'; 'normal'};
error_type_all = {'5'; '10'; '15'; 'normal'; 'outlier'};
n_rep = 1:100; % A number of times
i = 1; % count iterations

if n_rep(1) ~= 1
    try load results
    catch
        print('Not starting on 1st repetition and error load results')
    end
end

results = struct('Sampling', {''}, 'Prob_dist', {''}, 'Error_type', {''},...
          'Repetition', {''}, 'ReshapeData_all', {[]}, 'CV_all', {[]});

for e = 1:length(error_type_all)
    for d = 1:length(dist_type_all)
        for s = 1:length(sampling_all)
            % In case of outlier error, test outlier in all variables
            if strcmp(error_type_all{e}, 'outlier')
                for out = 1:10
                    [ReshapedData_all, CV_all, data, itsample, iunknown,...
                        imeasured] = FedBatch_MtiFA_SimulationCase1(sampling_all{s},...
                        error_type_all{e}, dist_type_all{d}, n_rep, out);
                    results.Sampling{i} = sampling_all{s};
                    results.Prob_dist{i} = dist_type_all{d};
                    results.Error_type{i} = error_type_all{e};
                    results.Repetition{i} = num2str(n_rep);
                    results.ReshapeData_all{i} = ReshapedData_all;
                    results.CV_all{i} = CV_all;
                    i = i + 1;
                end
            else
                out = 0;
                [ReshapedData_all, CV_all, data, itsample, iunknown,...
                    imeasured] = FedBatch_MtiFA_SimulationCase1(sampling_all{s},...
                    error_type_all{e}, dist_type_all{d}, n_rep, out);
            end
            % Organize data set
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%%%%%%%%%%%% ADD OUTPUT FROM INTEGRATEDMFA %%%%%%%%%%%%%%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if ~strcmp(error_type_all{e}, 'outlier')
                results.Sampling{i} = sampling_all{s};
                results.Prob_dist{i} = dist_type_all{d};
                results.Error_type{i} = error_type_all{e};
                results.Repetition{i} = num2str(n_rep);
                results.ReshapeData_all{i} = ReshapedData_all;
                results.CV_all{i} = CV_all;
                i = i + 1;
            end
        end
    end
end

save results results
