clear
close all
clc

% Test all conditions
sampling_all = {'normal'; 'hourly'; '5'};
dist_type_all = {'normal'};%'beta'; 
error_type_all = {'5'; '10'; '15'; 'normal'; 'outlier'};
is_rev = [1 0];
is_det = [1 0];
n_rep = 100;   % A number of times
i = 1;         % Count iterations

if n_rep(1) ~= 1
    try load results_case2
    catch
        disp('Not starting on 1st repetition and error load results')
    end
end

results_case2 = struct('Sampling', {''}, 'Prob_dist', {''}, ...
    'Error_type', {''}, 'Repetition', {''}, 'ReshapeData_all', {[]}, ...
    'CV_all', {[]}, 'Is_rev', {[]}, 'Is_deter', {[]});

for r = 1:length(is_rev) 
for det = 1:length(is_det)
for e = 1:length(error_type_all)
    for d = 1:length(dist_type_all)
        for s = 1:length(sampling_all)
            disp(['s',num2str(s),'d',num2str(d),'e',num2str(e),'det',num2str(det),'r',num2str(r)])
            % In case of outlier error, test outlier in all variables
            if strcmp(error_type_all{e}, 'outlier')
                for out = 1:6
                    disp(['out', num2str(out)])
                    [CV, FeedEst, dm, add, noise] = FedBatch_MtiFA_SimulationCase2(...
                     sampling_all{s}, error_type_all{e}, ...
                     dist_type_all{d}, n_rep, out, is_det(det), is_rev(r));
                    results_case2.Sampling{i}   = sampling_all{s};
                    results_case2.Prob_dist{i}  = dist_type_all{d};
                    results_case2.Error_type{i} = error_type_all{e};
                    results_case2.Repetition{i} = num2str(n_rep);
                    results_case2.Is_rev{i}     = is_rev(r);
                    results_case2.Is_deter{i}   = is_det(det);
                    results_case2.ReshapeData_all{i} = 0;
                    results_case2.CV_all{i} = CV;
                    results_case2.dm{i} = dm;
                    results_case2.FeedEst{i} = FeedEst;
                    results_case2.add_noise{i} = add;
                    results_case2.noise{i} = noise;
                    i = i + 1;
                end
            else
                out = 0;
                [CV, FeedEst, dm, add, noise] = FedBatch_MtiFA_SimulationCase2(...
                    sampling_all{s}, error_type_all{e}, dist_type_all{d},...
                    n_rep, out, is_det(det), is_rev(r));
            end
            % Organize data set
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%%%%%%%%%%%% ADD OUTPUT FROM INTEGRATEDMFA %%%%%%%%%%%%%%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if ~strcmp(error_type_all{e}, 'outlier')
                results_case2.Sampling{i}   = sampling_all{s};
                results_case2.Prob_dist{i}  = dist_type_all{d};
                results_case2.Error_type{i} = error_type_all{e};
                results_case2.Repetition{i} = num2str(n_rep);
                results_case2.Is_rev{i}     = is_rev(r);
                results_case2.Is_deter{i}   = is_det(det);
                results_case2.ReshapeData_all{i} = 0;
                results_case2.CV_all{i} = CV;
                results_case2.dm{i} = dm;
                results_case2.FeedEst{i} = FeedEst;
                results_case2.add_noise{i} = add;
                results_case2.noise{i} = noise;
                i = i + 1;
            end
        end
    end
end
end
end

save results_case2 results_case2
